OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
juce::dsp::IIR::Filter< SampleType > Class Template Reference

`#include <juce_IIRFilter.h>`

## Public Types
using | NumericType = typename SampleTypeHelpers::ElementType< SampleType >::Type
using | CoefficientsPtr = typename Coefficients< NumericType >::Ptr

## Public Member Functions
| Filter ()
| Filter (CoefficientsPtr coefficientsToUse)
| Filter (const Filter &)=default
| Filter (Filter &&)=default
Filter & | operator= (const Filter &)=default
Filter & | operator= (Filter &&)=default
void | reset ()
void | reset (SampleType resetToValue)
void | prepare (const ProcessSpec &) noexcept
template<typename ProcessContext >
void | process (const ProcessContext &context) noexcept
SampleType JUCE_VECTOR_CALLTYPE | processSample (SampleType sample) noexcept
void | snapToZero () noexcept

## Public Attributes
CoefficientsPtr | coefficients

## Detailed Description

template<typename SampleType>
class juce::dsp::IIR::Filter< SampleType >

A processing class that can perform IIR filtering on an audio signal, using the Transposed Direct Form II digital structure.

If you need a lowpass, bandpass or highpass filter with fast modulation of its cutoff frequency, you might use the class StateVariableFilter instead, which is designed to prevent artefacts at parameter changes, instead of the class Filter.

See also
  Filter::Coefficients, FilterAudioSource, StateVariableFilter

Definition at line 54 of file juce_dsp/processors/juce_IIRFilter.h.

## Member Typedef Documentation

## ◆ CoefficientsPtr

template<typename SampleType >

using juce::dsp::IIR::Filter< SampleType >::CoefficientsPtr = typename Coefficients<NumericType>::Ptr

A typedef for a ref-counted pointer to the coefficients object

Definition at line 63 of file juce_dsp/processors/juce_IIRFilter.h.

## ◆ NumericType

template<typename SampleType >

using juce::dsp::IIR::Filter< SampleType >::NumericType = typename SampleTypeHelpers::ElementType<SampleType>::Type

The NumericType is the underlying primitive type used by the SampleType (which could be either a primitive or vector)

Definition at line 60 of file juce_dsp/processors/juce_IIRFilter.h.

## Constructor & Destructor Documentation

## ◆ Filter() [1/2]

template<typename SampleType >

juce::dsp::IIR::Filter< SampleType >::Filter

Creates a filter.

Initially the filter is inactive, so will have no effect on samples that you process with it. You can modify the coefficients member to turn it into the type of filter needed.

Definition at line 38 of file juce_IIRFilter_Impl.h.

## ◆ Filter() [2/2]

template<typename SampleType >

juce::dsp::IIR::Filter< SampleType >::Filter | ( | CoefficientsPtr | coefficientsToUse | ) |

Creates a filter with a given set of coefficients.

Definition at line 45 of file juce_IIRFilter_Impl.h.

## Member Function Documentation

## ◆ prepare()

template<typename SampleType >

void juce::dsp::IIR::Filter< SampleType >::prepare | ( | const ProcessSpec & |  | ) |
| noexcept

Called before processing starts.

Definition at line 67 of file juce_IIRFilter_Impl.h.

## ◆ process()

template<typename SampleType >
template<typename ProcessContext >

void juce::dsp::IIR::Filter< SampleType >::process | ( | const ProcessContext & | context | ) |
| inline noexcept

Processes a block of samples

Definition at line 110 of file juce_dsp/processors/juce_IIRFilter.h.

## ◆ processSample()

template<typename SampleType >

SampleType JUCE_VECTOR_CALLTYPE juce::dsp::IIR::Filter< SampleType >::processSample | ( | SampleType | sample | ) |
| noexcept

Processes a single sample, without any locking.

Use this if you need processing of a single value.

Moreover, you might need the function snapToZero after a few calls to avoid potential denormalisation issues.

Definition at line 191 of file juce_IIRFilter_Impl.h.

## ◆ reset() [1/2]

template<typename SampleType >

void juce::dsp::IIR::Filter< SampleType >::reset | ( |  | ) |
| inline

Resets the filter's processing pipeline, ready to start a new stream of data.

Note that this clears the processing state, but the type of filter and its coefficients aren't changed.

Definition at line 97 of file juce_dsp/processors/juce_IIRFilter.h.

Referenced by juce::dsp::IIR::Filter< SampleType >::Filter(), and juce::dsp::IIR::Filter< SampleType >::reset().

## ◆ reset() [2/2]

template<typename SampleType >

void juce::dsp::IIR::Filter< SampleType >::reset | ( | SampleType | resetToValue | ) |

Resets the filter's processing pipeline to a specific value.

See also
  reset

Definition at line 51 of file juce_IIRFilter_Impl.h.

## ◆ snapToZero()

template<typename SampleType >

void juce::dsp::IIR::Filter< SampleType >::snapToZero
| noexcept

Ensure that the state variables are rounded to zero if the state variables are denormals. This is only needed if you are doing sample by sample processing.

Definition at line 207 of file juce_IIRFilter_Impl.h.

## Member Data Documentation

## ◆ coefficients

template<typename SampleType >

CoefficientsPtr juce::dsp::IIR::Filter< SampleType >::coefficients

The coefficients of the IIR filter. It's up to the caller to ensure that these coefficients are modified in a thread-safe way.

If you change the order of the coefficients then you must call reset after modifying them.

Definition at line 89 of file juce_dsp/processors/juce_IIRFilter.h.

Referenced by juce::dsp::IIR::Coefficients< NumericType >::getRawCoefficients().

The documentation for this class was generated from the following files:

- juce_dsp/processors/juce_IIRFilter.h
- juce_IIRFilter_Impl.h